<template>
  <single-pane capt="Доменные настройки">
    <domain-settings-grid
      :settings="domainSettings"
      @change-setting="changeSetting"
      @save="onSave"
      @revert="onRevert"
    />
  </single-pane>
</template>

<script>
import api from '@/api';
import cloneDeep from 'clone-deep';
import SinglePane from 'common-components/src/obComponents/obSinglePanels';
import { getCookie } from '@/utils/cookie';
import jwt_decode from 'jwt-decode';

import {
  PARTICIPANT_ROLES,
  VIEW_DIRECTION,
  VISIBILITY_PERMISSION,
  LINK_PERMISSION
} from '@/resources/log_domains_const';
import {
  GET_CHANGED_DOMAIN_SETTINGS,
  GET_CHANGED_LINK_SETTING,
  GET_PREPARED_SETTINGS
} from '@/helpers/logistic-domains/expeditor/domain-settings';
import DomainSettingsGrid from './domain-settings/DomainSettingsGrid';

const token = getCookie('auth_token');
const userData = token ? jwt_decode(token) : {};
export default {
  name: 'DomainSettingsExpeditor',
  components: { DomainSettingsGrid, SinglePane },
  computed: {
    api() {
      return api.domainSettingsExpeditor;
    },
    linkAccessList() {
      return [
        {
          access: LINK_PERMISSION.ALLOWED,
          name: 'Может создать линк',
          description: 'Некоторое описание параметров видимости'
        },
        {
          access: LINK_PERMISSION.BY_REQUEST,
          name: 'Требует согласования',
          description: 'Некоторое описание параметров видимости'
        },
        {
          access: LINK_PERMISSION.DISALLOWED,
          name: 'Не может создать линк',
          description: 'Некоторое описание параметров видимости'
        }
      ];
    },
    accessList() {
      return [
        {
          access: VISIBILITY_PERMISSION.VISIBILITY,
          name: 'Видит',
          description: 'Некоторое описание параметров видимости'
        },
        {
          access: VISIBILITY_PERMISSION.NOT_VISIBILITY,
          name: 'Не видит',
          description: 'Некоторое описание параметров видимости'
        }
      ];
    },
    orgInDomainSettings() {
      return [
        {
          id: 1,
          name: 'Я',
          description: 'вижу',
          role: PARTICIPANT_ROLES.EXPEDITOR,
          viewDirection: VIEW_DIRECTION.BY_PARTICIPANT,
          accessList: [
            {
              keyAccess: 0,
              disabled: true,
              availableAccessList: this.accessList,
              type: 'Модератора',
              access: VISIBILITY_PERMISSION.VISIBILITY
            },
            {
              keyAccess: 1,
              disabled: true,
              availableAccessList: this.accessList,
              type: 'Моих Клиентов и Поставщиков',
              access: VISIBILITY_PERMISSION.VISIBILITY
            },
            {
              keyAccess: 2,
              disabled: true,
              availableAccessList: this.accessList,
              moderator: true,
              type: 'Других Экспедиторов',
              access: VISIBILITY_PERMISSION.VISIBILITY
            },
            {
              keyAccess: 3,
              disabled: false,
              availableAccessList: this.accessList,
              type: 'Чужих Клиентов и Поставщиков',
              access: VISIBILITY_PERMISSION.VISIBILITY
            }
          ]
        },
        {
          id: 2,
          name: 'Мои Клиенты',
          description: 'видят',
          role: PARTICIPANT_ROLES.CLIENT,
          viewDirection: VIEW_DIRECTION.BY_PARTICIPANT,
          accessList: [
            {
              keyAccess: 0,
              disabled: true,
              availableAccessList: this.accessList,
              type: 'Меня',
              access: VISIBILITY_PERMISSION.VISIBILITY
            },
            {
              keyAccess: 1,
              disabled: false,
              availableAccessList: this.accessList,
              type: 'Моих Поставщиков',
              access: VISIBILITY_PERMISSION.VISIBILITY
            },
            {
              keyAccess: 2,
              disabled: false,
              availableAccessList: this.accessList,
              type: 'Модератора и других Экспедиторов',
              access: VISIBILITY_PERMISSION.VISIBILITY
            },
            {
              keyAccess: 3,
              disabled: false,
              availableAccessList: this.accessList,
              type: 'Чужих Поставщиков',
              access: VISIBILITY_PERMISSION.VISIBILITY
            }
          ]
        },
        {
          id: 3,
          name: 'Мои Поставщики',
          description: 'видят',
          role: PARTICIPANT_ROLES.CARRIER,
          viewDirection: VIEW_DIRECTION.BY_PARTICIPANT,
          accessList: [
            {
              keyAccess: 0,
              disabled: true,
              availableAccessList: this.accessList,
              type: 'Меня',
              access: VISIBILITY_PERMISSION.VISIBILITY
            },
            {
              keyAccess: 1,
              disabled: false,
              availableAccessList: this.accessList,
              type: 'Моих Клиентов',
              access: VISIBILITY_PERMISSION.VISIBILITY
            },
            {
              keyAccess: 2,
              disabled: false,
              availableAccessList: this.accessList,
              type: 'Модератора и других Экспедиторов',
              access: VISIBILITY_PERMISSION.VISIBILITY
            },
            {
              keyAccess: 3,
              disabled: false,
              availableAccessList: this.accessList,
              type: 'Чужих Клиентов',
              access: VISIBILITY_PERMISSION.VISIBILITY
            }
          ]
        }
      ];
    },
    orgInDomainFromOtherOrgSettings() {
      return [
        {
          id: 1,
          name: 'Меня',
          description: 'видят',
          role: PARTICIPANT_ROLES.EXPEDITOR,
          viewDirection: VIEW_DIRECTION.AT_PARTICIPANT,
          accessList: [
            {
              keyAccess: 0,
              disabled: true,
              availableAccessList: this.accessList,
              type: 'Модератор',
              access: VISIBILITY_PERMISSION.VISIBILITY
            },
            {
              keyAccess: 1,
              disabled: true,
              availableAccessList: this.accessList,
              type: 'Мои Клиенты и Поставщики',
              access: VISIBILITY_PERMISSION.VISIBILITY
            },
            {
              keyAccess: 2,
              disabled: true,
              availableAccessList: this.accessList,
              moderator: true,
              type: 'Другие Экспедиторы',
              access: VISIBILITY_PERMISSION.VISIBILITY
            },
            {
              keyAccess: 3,
              disabled: false,
              availableAccessList: this.accessList,
              type: 'Чужие Клиенты и Поставщики',
              access: VISIBILITY_PERMISSION.VISIBILITY
            }
          ]
        },
        {
          id: 2,
          name: 'Моих Клиентов',
          description: 'видят',
          role: PARTICIPANT_ROLES.CLIENT,
          viewDirection: VIEW_DIRECTION.AT_PARTICIPANT,
          accessList: [
            {
              keyAccess: 0,
              disabled: true,
              availableAccessList: this.accessList,
              type: 'Я',
              access: VISIBILITY_PERMISSION.VISIBILITY
            },
            {
              keyAccess: 1,
              disabled: false,
              availableAccessList: this.accessList,
              type: 'Мои Поставщики',
              access: VISIBILITY_PERMISSION.VISIBILITY
            },
            {
              keyAccess: 2,
              disabled: false,
              availableAccessList: this.accessList,
              type: 'Модератор и другие Экспедиторы',
              access: VISIBILITY_PERMISSION.VISIBILITY
            },
            {
              keyAccess: 3,
              disabled: false,
              availableAccessList: this.accessList,
              type: 'Чужие Поставщики',
              access: VISIBILITY_PERMISSION.VISIBILITY
            }
          ]
        },
        {
          id: 3,
          name: 'Моих Поставщиков',
          description: 'видят',
          role: PARTICIPANT_ROLES.CARRIER,
          viewDirection: VIEW_DIRECTION.AT_PARTICIPANT,
          accessList: [
            {
              keyAccess: 0,
              disabled: true,
              availableAccessList: this.accessList,
              type: 'Я',
              access: VISIBILITY_PERMISSION.VISIBILITY
            },
            {
              keyAccess: 1,
              disabled: false,
              availableAccessList: this.accessList,
              type: 'Мои Клиенты',
              access: VISIBILITY_PERMISSION.VISIBILITY
            },
            {
              keyAccess: 2,
              disabled: false,
              availableAccessList: this.accessList,
              type: 'Модератор и другие Экспедиторы',
              access: VISIBILITY_PERMISSION.VISIBILITY
            },
            {
              keyAccess: 3,
              disabled: false,
              availableAccessList: this.accessList,
              type: 'Чужие Клиенты',
              access: VISIBILITY_PERMISSION.VISIBILITY
            }
          ]
        }
      ];
    },
    accessCreateLinkForOrgInDomainSettings() {
      return [
        {
          id: 1,
          name: 'Я',
          description: 'могу создавать',
          role: PARTICIPANT_ROLES.EXPEDITOR,
          viewDirection: VIEW_DIRECTION.LINKS,
          accessList: [
            {
              keyAccess: 0,
              disabled: true,
              availableAccessList: this.linkAccessList,
              type: 'Внутренние линки с моими Клиентами и Поставщиками',
              access: LINK_PERMISSION.ALLOWED
            },
            {
              keyAccess: 1,
              disabled: true,
              availableAccessList: this.linkAccessList,
              moderator: true,
              type: 'Внешние линки с другими Экспедиторами',
              access: LINK_PERMISSION.ALLOWED
            },
            {
              keyAccess: 2,
              disabled: false,
              availableAccessList: this.linkAccessList,
              type: 'Внешние линки с чужими Клиентами и Поставщиками',
              access: LINK_PERMISSION.ALLOWED
            },
            {
              keyAccess: 3,
              disabled: false,
              availableAccessList: this.linkAccessList,
              type: 'Публичные линки',
              access: LINK_PERMISSION.ALLOWED
            }
          ]
        },
        {
          id: 2,
          name: 'Мои Клиенты',
          description: 'могут создавать',
          role: PARTICIPANT_ROLES.CLIENT,
          viewDirection: VIEW_DIRECTION.LINKS,
          accessList: [
            {
              keyAccess: 0,
              disabled: false,
              availableAccessList: this.linkAccessList,
              type: 'Внутренние линки с моими Поставщиками',
              access: LINK_PERMISSION.ALLOWED
            },
            {
              keyAccess: 1,
              disabled: false,
              availableAccessList: this.linkAccessList,
              type: 'Внешние линки с Модератором и другими Экспедиторами',
              access: LINK_PERMISSION.ALLOWED
            },
            {
              keyAccess: 2,
              disabled: false,
              availableAccessList: this.linkAccessList,
              type: 'Внешние линки с чужими Поставщиками',
              access: LINK_PERMISSION.ALLOWED
            },
            {
              keyAccess: 3,
              disabled: false,
              availableAccessList: this.linkAccessList,
              type: 'Публичные линки',
              access: LINK_PERMISSION.ALLOWED
            }
          ]
        },
        {
          id: 3,
          name: 'Мои Поставщики',
          description: 'могут создавать',
          role: PARTICIPANT_ROLES.CARRIER,
          viewDirection: VIEW_DIRECTION.LINKS,
          accessList: [
            {
              keyAccess: 0,
              disabled: false,
              availableAccessList: this.linkAccessList,
              type: 'Внутренние линки с моими Клиентами',
              access: LINK_PERMISSION.ALLOWED
            },
            {
              keyAccess: 1,
              disabled: false,
              availableAccessList: this.linkAccessList,
              type: 'Внешние линки с Модератором и другими Экспедиторами',
              access: LINK_PERMISSION.ALLOWED
            },
            {
              keyAccess: 2,
              disabled: false,
              availableAccessList: this.linkAccessList,
              type: 'Внешние линки с чужими Клиентами',
              access: LINK_PERMISSION.ALLOWED
            },
            {
              keyAccess: 3,
              disabled: false,
              availableAccessList: this.linkAccessList,
              type: 'Публичные линки',
              access: LINK_PERMISSION.ALLOWED
            }
          ]
        }
      ];
    }
  },
  data() {
    return {
      initialDomainSettings: [],
      domainSettings: [],
      timeSetting: 0,
      changedDomainParticipantSettings: {},
      changedTimeSetting: 0,
      userData
    };
  },
  mounted() {
    this.getDomainSettings();
  },
  methods: {
    async getDomainSettings() {
      try {
        let response = await Promise.all([
          this.api.getDomainSettings(),
          this.api.getTimeSettings()
        ]);
        this.initialDomainSettings = response[0].data
          ? response[0].data.settings
          : [];
        this.timeSetting = response[1].data
          ? response[1].data.requestLifetime
          : 0;
        this.domainSettings = this.getConvertedDomainSettings(
          this.initialDomainSettings,
          this.timeSetting
        );
      } catch (e) {
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных'
        });
      }
    },
    getConvertedDomainSettings(settings, timeSetting) {
      let _LGDSShowOrgInDomain = cloneDeep(this.orgInDomainSettings);
      let _LGDSShowOrgInDomainFromOtherOrgs = cloneDeep(
        this.orgInDomainFromOtherOrgSettings
      );
      let _LGDSAccessCreateLinkForOrgInDomain = cloneDeep(
        this.accessCreateLinkForOrgInDomainSettings
      );

      settings.forEach(setting => {
        let indexParticipantRole;
        switch (setting.participantRole) {
          case PARTICIPANT_ROLES.EXPEDITOR:
            indexParticipantRole = 0;
            break;
          case PARTICIPANT_ROLES.CLIENT:
            indexParticipantRole = 1;
            break;
          case PARTICIPANT_ROLES.CARRIER:
            indexParticipantRole = 2;
            break;
        }
        let indexTargetParticipantRole;
        let indexLinkPermission;
        switch (setting.targetParticipantRole) {
          case PARTICIPANT_ROLES.MODERATOR:
            indexTargetParticipantRole = !setting.isCrossDomainScope ? 0 : 2;
            break;
          case PARTICIPANT_ROLES.EXPEDITOR:
            indexTargetParticipantRole = !setting.isCrossDomainScope ? 0 : 2;
            if (setting.isCrossDomainScope) {
              indexLinkPermission = 1;
            }
            break;
          case PARTICIPANT_ROLES.CLIENT:
          case PARTICIPANT_ROLES.CARRIER:
            indexTargetParticipantRole = !setting.isCrossDomainScope ? 1 : 3;
            indexLinkPermission = !setting.isCrossDomainScope ? 0 : 2;
            break;
        }
        switch (setting.viewDirection) {
          case VIEW_DIRECTION.BY_PARTICIPANT:
            _LGDSShowOrgInDomain[indexParticipantRole].accessList[
              indexTargetParticipantRole
            ].access = setting.visibilityPermission;
            if (
              (setting.targetParticipantRole === PARTICIPANT_ROLES.EXPEDITOR &&
                setting.isCrossDomainScope) ||
              (setting.targetParticipantRole === PARTICIPANT_ROLES.MODERATOR &&
                setting.isCrossDomainScope) ||
              setting.targetParticipantRole === PARTICIPANT_ROLES.CLIENT ||
              setting.targetParticipantRole === PARTICIPANT_ROLES.CARRIER
            ) {
              _LGDSAccessCreateLinkForOrgInDomain[
                indexParticipantRole
              ].accessList[3].access = setting.publicateLinkPermission;
              if (setting.isPublicateLinkPermissionDisabled) {
                _LGDSAccessCreateLinkForOrgInDomain[
                  indexParticipantRole
                ].accessList[3].moderator = true;
                _LGDSAccessCreateLinkForOrgInDomain[
                  indexParticipantRole
                ].accessList[3].disabled = true;
              }
            }
            if (indexLinkPermission !== undefined) {
              _LGDSAccessCreateLinkForOrgInDomain[
                indexParticipantRole
              ].accessList[indexLinkPermission].access =
                setting.createLinkPermission;
              if (setting.isCreateLinkPermissionDisabled) {
                _LGDSAccessCreateLinkForOrgInDomain[
                  indexParticipantRole
                ].accessList[indexLinkPermission].moderator = true;
                _LGDSAccessCreateLinkForOrgInDomain[
                  indexParticipantRole
                ].accessList[indexLinkPermission].disabled = true;
              }
            }
            break;
          case VIEW_DIRECTION.AT_PARTICIPANT:
            _LGDSShowOrgInDomainFromOtherOrgs[indexParticipantRole].accessList[
              indexTargetParticipantRole
            ].access = setting.visibilityPermission;
            break;
        }
      });
      return [
        {
          id: 1,
          title: 'Кого вижу Я и Участники моего домена',
          viewDirection: VIEW_DIRECTION.BY_PARTICIPANT,
          type: 'access-grid',
          editItemCount: 0,
          value: _LGDSShowOrgInDomain
        },
        {
          id: 2,
          title: 'Как видят Меня и Участники моего домена другие',
          viewDirection: VIEW_DIRECTION.AT_PARTICIPANT,
          type: 'access-grid',
          editItemCount: 0,
          value: _LGDSShowOrgInDomainFromOtherOrgs
        },
        {
          id: 3,
          title: 'Правила создания линков для участников моего домена',
          viewDirection: VIEW_DIRECTION.LINKS,
          type: 'access-grid',
          editItemCount: 0,
          value: _LGDSAccessCreateLinkForOrgInDomain
        },
        {
          id: 4,
          title:
            'Лимит времени на принятия решения о создании или публикации линка',
          viewDirection: VIEW_DIRECTION.LIMIT,
          type: 'limit',
          editItemCount: 0,
          value: timeSetting
        }
      ];
    },
    changeSetting(row, access, status) {
      if (row.viewDirection === VIEW_DIRECTION.LIMIT) {
        this.changedTimeSetting = access;
      } else {
        if (!this.changedDomainParticipantSettings[row.viewDirection]) {
          this.changedDomainParticipantSettings[row.viewDirection] = [];
        }
        //Изменение видимости
        if (
          row.viewDirection === VIEW_DIRECTION.AT_PARTICIPANT ||
          row.viewDirection === VIEW_DIRECTION.BY_PARTICIPANT
        ) {
          this.changedDomainParticipantSettings[
            row.viewDirection
          ] = GET_CHANGED_DOMAIN_SETTINGS(
            this.changedDomainParticipantSettings[row.viewDirection],
            this.initialDomainSettings,
            row,
            access,
            status
          );
        }
        //Изменение возможности создания линков
        else if (row.viewDirection === VIEW_DIRECTION.LINKS) {
          this.changedDomainParticipantSettings[
            row.viewDirection
          ] = GET_CHANGED_LINK_SETTING(
            this.changedDomainParticipantSettings[row.viewDirection],
            row,
            access,
            status
          );
        }
      }
    },
    onSave(row) {
      let notificationId = new Date().getTime() + 'save';
      this.$notification({
        type: 'system_notification_in_load',
        message: 'Сохранение',
        id: notificationId
      });
      let preparedSettings;
      if (row.viewDirection !== VIEW_DIRECTION.LIMIT) {
        preparedSettings = GET_PREPARED_SETTINGS(
          row.viewDirection,
          this.initialDomainSettings,
          this.changedDomainParticipantSettings[row.viewDirection],
          this.userData
        );
        this.api
          .putDomainSettings({ settings: preparedSettings })
          .then(({ data }) => {
            console.log(data.settings);
            this.initialDomainSettings = cloneDeep(data.settings);
            let indexSettings;
            switch (row.viewDirection) {
              case VIEW_DIRECTION.BY_PARTICIPANT:
                indexSettings = 0;
                break;
              case VIEW_DIRECTION.AT_PARTICIPANT:
                indexSettings = 1;
                break;
              case VIEW_DIRECTION.LINKS:
                indexSettings = 2;
                break;
            }
            this.$set(
              this.domainSettings,
              indexSettings,
              this.getConvertedDomainSettings(
                this.initialDomainSettings,
                this.timeSetting
              )[indexSettings]
            );
            this.changedDomainParticipantSettings[row.viewDirection] = [];
            this.$notification({
              type: 'system_notification_success',
              message: 'Сохранено'
            });
          })
          .catch(e => {
            console.error(e);
            this.$notification({
              type: 'system_notification_error',
              message: 'Не сохранено'
            });
          })
          .finally(() => {
            this.$notification({ event: 'close', id: notificationId });
          });
      } else {
        this.api
          .putTimeSettings({
            requestLifetime: this.changedTimeSetting
          })
          .then(({ data } = {}) => {
            this.timeSetting = data.requestLifetime;
            this.$set(
              this.domainSettings,
              3,
              this.getConvertedDomainSettings(
                this.initialDomainSettings,
                data.requestLifetime
              )[3]
            );
            this.$notification({
              type: 'system_notification_success',
              message: 'Сохранено'
            });
          })
          .catch(e => {
            console.error(e);
            this.$notification({
              type: 'system_notification_error',
              message: 'Не сохранено'
            });
          })
          .finally(() => {
            this.$notification({ event: 'close', id: notificationId });
          });
      }
    },
    onRevert(row) {
      if (row.viewDirection !== VIEW_DIRECTION.LIMIT) {
        this.changedDomainParticipantSettings[row.viewDirection] = [];
      }
    }
  }
};
</script>
